//FLEXO CAMERA CONTROLLER
//ProxSensor.ino
//For Arduino Mega (1280)
//by Riley Johanson
//This code assumes the sensor is always powered by 5V (after going through a resistor)
//v.0.6
//Last updated July 22, 2015
 
#define INTERRUPT_PIN 3   //SDA 20: interrupt pin 3
#define SHUTTER_PIN 30
#define BAUDRATE 9600     //Default: 9600

int counter = 0;
int tooth = 10;
bool stopTrigger = false;
char incomingByte;
long incomingInteger = 0;

//Setup
void setup()
{ 
  pinMode(SHUTTER_PIN, OUTPUT);
  attachInterrupt(INTERRUPT_PIN, pulse, FALLING);  
  Serial.begin(BAUDRATE);
}

//ISR
void pulse()
{
  counter++;
  digitalWrite(SHUTTER_PIN, LOW);
  Serial.println(counter);
  Serial.println(tooth);
  //Serial.println(incomingInteger);
  //Serial.println("---");
  
  if(counter == tooth && stopTrigger == false)
  {
    counter = 0;
    digitalWrite(SHUTTER_PIN, HIGH); 
  }   
}

//Main loop - checks for input from the camera controller program
void loop()
{       
  int cmd;   
  incomingInteger = Serial.parseInt();
  
  if(incomingInteger > 40)
    tooth = incomingInteger;
  else if(incomingInteger == 1) stopTrigger = false;    //Start taking pictures
  else if(incomingInteger == 2) stopTrigger = true;     //Stop taking pictures
  else if(incomingInteger == 3)                         //Force picture
  {
    digitalWrite(SHUTTER_PIN, HIGH);
    delayMicroseconds(5);
    digitalWrite(SHUTTER_PIN, LOW);
  }
  else if(incomingInteger == 4) counter = counter - 2;      //Advance 1
  else if(incomingInteger == 5) counter = counter - 6;      //Advance 2
  else if(incomingInteger == 6) counter = counter + 2;      //Retard 1
  else if(incomingInteger == 7) counter = counter + 6;      //Retard 2
}
